# IRsUISysFactory Interface Reference

Inherits IUnknown.

List of all members.

## Public Member Functions
HRESULT | CreateUIControl ([in] const IID *piid,[out, retval] IRsUIControl **ppControl)
HRESULT | AttachUiControlToWnd ([in] IRsUIControl *pControl,[in] HWND wndParent,[in] RECT *pRect)
HRESULT | RegisterUIControls ([in]IRsUnknownUIPackage *pUnkUIPck)
HRESULT | GetUIControlDesc ([in] const IID *piid,[out, retval] IRsUIControlDesc **ppCtrlDesc)
HRESULT | CreateLEPanel ([in] IRsLEPanelData *pInitData,[out] IRsLEPanel **ppPanel)
HRESULT | DestroyLEPanel ([in] GUID idPanel)
HRESULT | GetLEPanelRect ([in] IRsNode *pNode,[out] RECT *rcPanel)
HRESULT | GetPanelById ([in] GUID idPanel,[out, retval] IRsLEPanel **ppPanel)
HRESULT | GetDescsForConn ([in] RtConDesc *tConDesc,[out, retval] LPSAFEARRAY *pDescArray)
HRESULT | GetAllDescs ([out, retval] LPSAFEARRAY *pDescArray)
HRESULT | CreateLEPanelInitData ([out, retval] IRsLEPanelInitData **ppInitData)
HRESULT | CreateUIControlDesc ([out, retval] IRsUIControlDesc **ppUICtrlDesc)
HRESULT | UpdatedNodeTable ([in] IRsNode *pNode,[in] GUID idExcludePanel,[in] RtUlong flag)
HRESULT | CreatePanelObj ([out, retval] IRsPanelObj **ppPanelObj)

## Detailed Description

System factory for creating nodes, data objects, etc...

## Member Function Documentation

HRESULT IRsUISysFactory::CreateUIControl | ( | [in] const IID * | piid,
|  | [out, retval] IRsUIControl ** | ppControl |
| ) |  |  |

Create UI control.

Parameters:

  | piid | [in] Pointer to interface ID of UI control.

Returns:
  ppControl [out, retval] Returned instance of UI control.

HRESULT IRsUISysFactory::AttachUiControlToWnd | ( | [in] IRsUIControl * | pControl,
|  | [in] HWND | wndParent,
|  | [in] RECT * | pRect |
| ) |  |  |

Attach UI control to window.

Parameters:

  | pControl | [in] The control that will be attached.
  | wndParent | [in] Handle to parent window, that will be used for window control creation.
  | pRect | [in] Pointer to the rectangle that will be filled up with UI control.

HRESULT IRsUISysFactory::RegisterUIControls | ( | [in] IRsUnknownUIPackage * | pUnkUIPck | ) |

Register UI control.

Parameters:

  | pUnkUIPck | [in] UI package interface.

HRESULT IRsUISysFactory::GetUIControlDesc | ( | [in] const IID * | piid,
|  | [out, retval] IRsUIControlDesc ** | ppCtrlDesc |
| ) |  |  |

Gets UI control descriptor.

Parameters:

  | piid | [in] Pointer to interface ID of UI control.

Returns:
  ppCtrlDesc [out, retval] Returned instance of UI control descriptor.

HRESULT IRsUISysFactory::CreateLEPanel | ( | [in] IRsLEPanelData * | pInitData,
|  | [out] IRsLEPanel ** | ppPanel |
| ) |  |  |

Create LE panel.

Parameters:

  | pInitData | [in] LE Panel initialize data.

Returns:
  ppPanel [out, retval] Returned instance of created LE panel.

HRESULT IRsUISysFactory::DestroyLEPanel | ( | [in] GUID | idPanel | ) |

Destroy LE panel.

Parameters:

  | idPanel | [in] GUID that specifies LE panel.

HRESULT IRsUISysFactory::GetLEPanelRect | ( | [in] IRsNode * | pNode,
|  | [out] RECT * | rcPanel |
| ) |  |  |

Get LE panel rectangle.

Parameters:

  | pNode | [in] Node with CON_UI_LAYOUT connector to retrieve IRdUITable.

Returns:
  rcPanel [out, retval] Pointer to a variable of type RECT that retrieves bounding rectangle of last aspect retrieved from UI table.

HRESULT IRsUISysFactory::GetPanelById | ( | [in] GUID | idPanel,
|  | [out, retval] IRsLEPanel ** | ppPanel |
| ) |  |  |

Get LE panel by Id.

Parameters:

  | idPanel | [in] GUID that specifies LE panel.

Returns:
  ppPanel [out, retval] Returned instance of wanted LE panel.

HRESULT IRsUISysFactory::GetDescsForConn | ( | [in] RtConDesc * | tConDesc,
|  | [out, retval] LPSAFEARRAY * | pDescArray |
| ) |  |  |

Get descriptors for connector data compatible with input connector descriptor.

Parameters:

  | tConDesc | [in] The connector descriptor.

Returns:
  pDescArray [out, retval] Array that will be filled up all descriptors.

HRESULT IRsUISysFactory::GetAllDescs | ( | [out, retval] LPSAFEARRAY * | pDescArray | ) |

Get all descriptors from table.

Returns:
  pDescArray [out, retval] Array that will be filled up all descriptors.

HRESULT IRsUISysFactory::CreateLEPanelInitData | ( | [out, retval] IRsLEPanelInitData ** | ppInitData | ) |

Create LE panel initialize data.

Returns:
  ppInitData [out, retval] Returned instance of created LE panel init data.

HRESULT IRsUISysFactory::CreateUIControlDesc | ( | [out, retval] IRsUIControlDesc ** | ppUICtrlDesc | ) |

Create UI control descriptor.

Returns:
  ppUICtrlDesc [out, retval] Returned instance of created UI control descriptor.

HRESULT IRsUISysFactory::UpdatedNodeTable | ( | [in] IRsNode * | pNode,
|  | [in] GUID | idExcludePanel,
|  | [in] RtUlong | flag |
| ) |  |  |

Update node table using flag, exclude panel specified by ID.

Parameters:

  | pNode | [in] Node representing LE panel. Panels with same full name will be updated.
  | idExcludePanel | [in] GUID of LE panel. Panels with same GUID will be excluded from update.
  | flag | [in] Flag used for UI table update.

HRESULT IRsUISysFactory::CreatePanelObj | ( | [out, retval] IRsPanelObj ** | ppPanelObj | ) |

Create panel object.

Returns:
  ppPanelObj [out, retval] Returned instance of created panel object.